/*jslint nomen: true*/
/*global console*/
(function (document, renderJS, QUnit) {
  "use strict";
  var test = QUnit.test,
    stop = QUnit.stop,
    start = QUnit.start,
    ok = QUnit.ok,
    expect = QUnit.expect,
    // equal = QUnit.equal,
    // throws = QUnit.throws,
    // deepEqual = QUnit.deepEqual,
    module = QUnit.module,
    // notEqual = QUnit.notEqual,
    root_gadget_defer = RSVP.defer(),
    jsonform_url = '../gadget_json_generated_form.html';

  // Keep track of the root gadget
  renderJS(window)
    .ready(function () {
      root_gadget_defer.resolve(this);
    });

  /////////////////////////////////////////////////////////////////
  // declareGadget
  /////////////////////////////////////////////////////////////////
  module("jsonform.declareGadget", {
    setup: function () {
      renderJS.clearGadgetKlassList();
    }
  });
  test('JSON Form gadget can be loaded', function () {
    stop();
    expect(1);
    root_gadget_defer.promise
      .then(function (root_gadget) {
        return root_gadget.declareGadget(
          jsonform_url,
          {
            sandbox: 'iframe',
            element: document.querySelector('#qunit-fixture')
          }
        );
      })
      .then(function (gadget) {
        ok(true, gadget);
      })
      .fail(function (error) {
        ok(false, error);
        console.warn(error);
        throw error;
      })
      .always(function () {
        start();
      });
  });

}(document, renderJS, QUnit));

